/*
Espe | Ein schlichtes Werkzeug zur Mitglieder-Verwaltung | Backend
Copyright (C) 2024 Christian Fraß

This program is free software: you can redistribute it and/or modify it under the terms of the GNU General Public 
License as published by the Free Software Foundation, either version 3 of the License, or (at your option) any later 
version.

This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied 
warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.

You should have received a copy of the GNU General Public License along with this program. If not, see 
<https://www.gnu.org/licenses/>. 
 */

namespace _espe.api
{
	
	/**
	 */
	export function make(
	) : lib_plankton.rest.type_rest
	{
		const rest_subject : lib_plankton.rest.type_rest = lib_plankton.rest.make(
			{
				"title": "espe",
				"versioning_method": "header",
				"versioning_header_name": "X-Api-Version",
				"set_access_control_headers": true,
				"authentication": {
					"kind": "key_header",
					"parameters": {"name": "X-Session-Key"}
				},
			}
		);
		// meta
		{
			_espe.api.register_meta_ping(rest_subject);
			_espe.api.register_meta_spec(rest_subject);
		}
		// session
		{
			_espe.api.register_session_begin(rest_subject);
			_espe.api.register_session_end(rest_subject);
		}
		// member
		{
			_espe.api.register_member_project(rest_subject);
			_espe.api.register_member_summon(rest_subject);
			_espe.api.register_member_info(rest_subject);
			_espe.api.register_member_register(rest_subject);
			_espe.api.register_member_list(rest_subject);
			_espe.api.register_member_read(rest_subject);
			_espe.api.register_member_modify(rest_subject);
			// _espe.api.register_member_delete(rest_subject);
			// password_change
			{
				_espe.api.register_member_password_change_initialize(rest_subject);
				_espe.api.register_member_password_change_execute(rest_subject);
			}
		}
		
		
		return rest_subject;
	}
	
}

